Attribute VB_Name = "OpenDialog"
Option Explicit

Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

Public Const OFN_EXTENSIONDIFFERENT = &H400
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_PATHMUSTEXIST = &H800

Function Dialog_Open$(F As Form, ByVal ftitle$, fpfad$, ByVal ffile$, ByVal szFilter$, ByVal fext$)
Dim OpenFile As OPENFILENAME
Dim szFile$, file$

    szFile$ = ffile$ + String$(128 - Len(ffile$), 0)
    
    With OpenFile
        .lStructSize = Len(OpenFile)
        .hwndOwner = F.hwnd
        .nFilterIndex = 1
        .nMaxFile = Len(szFile$)
        .flags = OFN_PATHMUSTEXIST Or OFN_FILEMUSTEXIST
        .lpstrFile = szFile$
        .lpstrFilter = szFilter$
        .lpstrTitle = ftitle$
        .lpstrDefExt = fext$
        .lpstrInitialDir = fpfad$
    End With
    
    If GetOpenFileName(OpenFile) = 0 Then
        Dialog_Open$ = ""
        Exit Function
    End If
    
    file$ = Left$(OpenFile.lpstrFile, InStr(OpenFile.lpstrFile, Chr$(0)) - 1)
    fpfad$ = Left$(file$, OpenFile.nFileOffset)
    Dialog_Open$ = Right$(file$, Len(file$) - OpenFile.nFileOffset)

End Function



