Attribute VB_Name = "Subclass"
Option Explicit

' Typen
Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
 End Type

' API-Deklarationen
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestempDC As Long, ByVal x As Long, _
  ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, _
  ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function ValidateRectBynum Lib "user32" Alias "ValidateRect" (ByVal hwnd As Long, ByVal lpRect As Long) As Long

' Konstante
Public Const GW_CHILD = 5       ' Ermittelt mit GetWindow das Child-Fenster
Public Const GWL_WNDPROC = (-4) ' Neue WindowProc setzen
Public Const WM_PAINT = &HF     ' Neuzeichnen-Nachricht
Public OldProc As Long          ' Adresse der originalen WindowProc

Private Const SRCCOPY = &HCC0020    ' Kopier-Flag fr BitBlt
Private Const WM_ERASEBKGND = &H14  ' Hintergrund lschen-Nachricht

Public Function GetMessage(ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim BackgroundDC As Long
Dim ShadowDC As Long
Dim OriginalBitmap As Long
Dim CompatibleBitmap As BITMAP
Dim ClientRect As RECT
Dim x As Integer, y As Integer
    
    ' Nachricht an originale Prozedur weitergeben
    GetMessage = CallWindowProc(OldProc, hwnd, wMsg, wParam, lParam)
    
    ' Wenn Hintergrund gelscht werden oder neu gezeichnet werden soll
    If wMsg = WM_ERASEBKGND Or wMsg = WM_PAINT Then
        
        ' DC ermitteln, kompatiblen DC im Speicher erzeugen
        BackgroundDC = GetDC(hwnd)
        ShadowDC = CreateCompatibleDC(BackgroundDC)
        
        ' Hintergrundbild in erzeugten DC whlen
        OriginalBitmap = SelectObject(ShadowDC, Main.BackgroundPic.Picture)
        
        ' Informationen ber die Bitmap ermitteln (uns interessieren nur Hhe und Breite)
        GetObjectAPI Main.BackgroundPic.Picture, Len(CompatibleBitmap), CompatibleBitmap
        
        ' Gre des MDI-Background ermitteln
        GetClientRect hwnd, ClientRect
        
        ' Bild in X- und Y-Richtung so oft aus dem ShadowDC in den BackgroundDC
        ' kopieren, wie es zur Fllung der Flche notwendig ist
        For x = 0 To Int(ClientRect.Right / CompatibleBitmap.bmWidth)
            For y = 0 To Int(ClientRect.Bottom / CompatibleBitmap.bmHeight)
                
                BitBlt BackgroundDC, x * CompatibleBitmap.bmWidth, y * CompatibleBitmap.bmHeight, _
                       CompatibleBitmap.bmWidth, CompatibleBitmap.bmHeight, ShadowDC, 0, 0, SRCCOPY
                       
            Next y
        Next x
        
        ' Aufrumen
        SelectObject ShadowDC, OriginalBitmap
        DeleteDC ShadowDC
        
        ' Neuzeichnen auslsen
        ValidateRectBynum hwnd, 0

    End If

End Function
